## qt6-base 6.4.2%2Bdfsg

=== qmake/CMakeLists.txt ===
# Generated from qmake.pro.

#####################################################################
## qmake Tool:
#####################################################################

# The common object library, that should be available regardless of the presence of qmake.
qt_add_library(QtLibraryInfo OBJECT
    library/proitems.cpp library/proitems.h
    library/qmake_global.h
    property.cpp property.h
    propertyprinter.cpp propertyprinter.h
    qmakelibraryinfo.cpp qmakelibraryinfo.h
)
set_target_properties(QtLibraryInfo PROPERTIES
    COMPILE_OPTIONS $<TARGET_PROPERTY:Qt::Core,INTERFACE_COMPILE_OPTIONS>
    COMPILE_DEFINITIONS $<TARGET_PROPERTY:Qt::Core,INTERFACE_COMPILE_DEFINITIONS>
    INCLUDE_DIRECTORIES $<TARGET_PROPERTY:Qt::Core,INTERFACE_INCLUDE_DIRECTORIES>
    INCLUDE_DIRECTORIES $<TARGET_PROPERTY:Qt::CorePrivate,INTERFACE_INCLUDE_DIRECTORIES>
)
target_include_directories(QtLibraryInfo PUBLIC
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_SOURCE_DIR}/library"
)

# Chop off the "/mkspecs" part of INSTALL_MKSPECSDIR
get_filename_component(hostdatadir "${INSTALL_MKSPECSDIR}" DIRECTORY)
if("${hostdatadir}" STREQUAL "")
    set(hostdatadir ".")
endif()

target_compile_definitions(QtLibraryInfo PUBLIC
    PROEVALUATOR_FULL
    QT_BUILD_QMAKE
    QT_USE_QSTRINGBUILDER
    QT_NO_FOREACH
    QT_HOST_MKSPEC="${QT_QMAKE_HOST_MKSPEC}"
    QT_TARGET_MKSPEC="${QT_QMAKE_TARGET_MKSPEC}"
    QT_HOST_DATADIR="${hostdatadir}"
)

if(NOT QT_FEATURE_qmake)
    return()
endif()

qt_get_tool_target_name(target_name qmake)
qt_internal_add_tool(${target_name}
    TOOLS_TARGET Core # special case
    USER_FACING
    INSTALL_VERSIONED_LINK
    SOURCES
        cachekeys.h
        generators/mac/pbuilder_pbx.cpp generators/mac/pbuilder_pbx.h
        generators/makefile.cpp generators/makefile.h
        generators/makefiledeps.cpp generators/makefiledeps.h
        generators/metamakefile.cpp generators/metamakefile.h
        generators/projectgenerator.cpp generators/projectgenerator.h
        generators/unix/unixmake.cpp generators/unix/unixmake.h
        generators/unix/unixmake2.cpp
        generators/win32/mingw_make.cpp generators/win32/mingw_make.h
        generators/win32/msbuild_objectmodel.cpp generators/win32/msbuild_objectmodel.h
        generators/win32/msvc_nmake.cpp generators/win32/msvc_nmake.h
        generators/win32/msvc_objectmodel.cpp generators/win32/msvc_objectmodel.h
        generators/win32/msvc_vcproj.cpp generators/win32/msvc_vcproj.h
        generators/win32/msvc_vcxproj.cpp generators/win32/msvc_vcxproj.h
        generators/win32/winmakefile.cpp generators/win32/winmakefile.h
        generators/xmloutput.cpp generators/xmloutput.h
        library/ioutils.cpp library/ioutils.h
        library/qmakebuiltins.cpp
        library/qmakeevaluator.cpp library/qmakeevaluator.h library/qmakeevaluator_p.h
        library/qmakeglobals.cpp library/qmakeglobals.h
        library/qmakeparser.cpp library/qmakeparser.h
        library/qmakevfs.cpp library/qmakevfs.h
        main.cpp
        meta.cpp meta.h
        option.cpp option.h
        project.cpp project.h
    DEFINES
        HAVE_CONFIG_H
    INCLUDE_DIRECTORIES
        generators
        generators/mac
        generators/unix
        generators/win32
        library
    PRECOMPILED_HEADER
        "qmake_pch.h"
    LIBRARIES
        Qt::CorePrivate
        QtLibraryInfo
)
qt_internal_return_unless_building_tools()

# Add QMAKE_VERSION_STR only if qmake is part of the build.
target_compile_definitions(QtLibraryInfo PUBLIC
        QMAKE_VERSION_STR="3.1"
)

#### Keys ignored in scope 1:.:.:qmake.pro:<TRUE>:
# _OPTION = "host_build"

## Scopes:
#####################################################################

qt_internal_extend_target(${target_name} CONDITION MACOS
    COMPILE_OPTIONS
        "-fconstant-cfstrings"
)

# special case big
qt_internal_extend_target(${target_name} CONDITION WIN32
    SOURCES
        library/registry.cpp
    DEFINES
        _SCL_SECURE_NO_WARNINGS
)

qt_internal_extend_target(${target_name} CONDITION CLANG AND WIN32
    COMPILE_OPTIONS
        "-fms-compatibility-version=19.00.23506"
        "-Wno-microsoft-enum-value"
)

# special case:
set_target_properties(${target_name} PROPERTIES
    AUTOMOC OFF
    AUTORCC OFF
    AUTOUIC OFF
)

qt_internal_apply_gc_binaries(${target_name} PRIVATE) # special case
qt_skip_warnings_are_errors(${target_name}) # special case

# special case begin
qt_internal_add_docs(${target_name}
    doc/qmake.qdocconf
)
# special case end

=== src/CMakeLists.txt ===
# special case skip regeneration

# We need to include the features of a few modules before they are actually declared.
# The feature values are used as conditions for deciding whether bundled 3rd party libraries
# should be built.
# The order of evaluation matters.
qt_feature_evaluate_features("${CMAKE_CURRENT_SOURCE_DIR}/corelib/configure.cmake")
if(QT_FEATURE_network)
    qt_feature_evaluate_features("${CMAKE_CURRENT_SOURCE_DIR}/network/configure.cmake")
endif()
if(QT_FEATURE_gui)
    qt_feature_evaluate_features("${CMAKE_CURRENT_SOURCE_DIR}/gui/configure.cmake")
endif()

function(find_or_build_bootstrap_names)
    if (QT_WILL_BUILD_TOOLS)
        add_subdirectory(tools/bootstrap)  # bootstrap library
    endif()
    add_subdirectory(tools/moc)
    add_subdirectory(tools/rcc)
    add_subdirectory(tools/tracegen)
    add_subdirectory(tools/cmake_automoc_parser)
endfunction()

find_or_build_bootstrap_names()

add_subdirectory(entrypoint)

# These 3rd party libraries need to be built before corelib, because corelib
# does qt_find_package for them.
if(QT_FEATURE_regularexpression AND NOT QT_FEATURE_system_pcre2)
    add_subdirectory(3rdparty/pcre2)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledPcre2)

if(NOT QT_FEATURE_system_zlib)
    add_subdirectory(3rdparty/zlib)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledZLIB)

add_subdirectory(corelib)

# Needs to be after corelib, because some of them reference Core.
add_subdirectory(3rdparty)

if (QT_FEATURE_concurrent)
    add_subdirectory(concurrent)
endif()
if (QT_FEATURE_sql)
    add_subdirectory(sql)
endif()
if (QT_FEATURE_network)
    add_subdirectory(network)
    if (ANDROID)
        add_subdirectory(network/android/jar)
    endif()
endif()
if (QT_FEATURE_xml)
    add_subdirectory(xml)
endif()

if (QT_FEATURE_dbus)
    add_subdirectory(dbus)
endif()

add_subdirectory(tools)

if(QT_FEATURE_gui)
    add_subdirectory(gui)

    if(QT_FEATURE_opengl)
        add_subdirectory(opengl)
    endif()

    if(QT_FEATURE_widgets)
        add_subdirectory(widgets)
        if(QT_FEATURE_opengl)
            add_subdirectory(openglwidgets)
        endif()
    endif()
    add_subdirectory(platformsupport)
endif()
if (QT_FEATURE_testlib)
    add_subdirectory(testlib)
endif()
if(QT_FEATURE_printsupport)
   add_subdirectory(printsupport)
endif()
add_subdirectory(plugins)

add_subdirectory(android)

=== cmake/tests/CMakeLists.txt ===
# These macros are inspired by ECM:

# a macro for tests that have a simple format where the name matches the
# directory and project

# The following macros will produce tests that generate the build
# system for the test project, build it and then run its tests.
macro(add_cmake_test_generate_build_run_variant name base command)
    string(REPLACE "." "/" src_dir "${base}")
    string(REPLACE "." "/" build_dir "${name}")
    string(REGEX REPLACE "[^.]*\\." "" proj "${name}")
    add_test(NAME "cmake_${name}"
        COMMAND ${CMAKE_CTEST_COMMAND}
            --build-and-test
                "${CMAKE_CURRENT_SOURCE_DIR}/${src_dir}"
                "${CMAKE_CURRENT_BINARY_DIR}/${build_dir}"
            --build-two-config
            --build-generator ${CMAKE_GENERATOR}
            --build-makeprogram ${CMAKE_MAKE_PROGRAM}
            --build-project ${proj}
            ${${name}_EXTRA_OPTIONS}
            --test-command ${command} ${ARGN})
endmacro()

macro(add_cmake_test_generate_build_run name)
    add_cmake_test_generate_build_run_variant("${name}" "${name}" ${ARGN})
endmacro()

# The following macros will produce tests that just run cmake
# to generate the build system for the test project.
macro(add_cmake_test_generate_variant name base)
    string(REPLACE "." "/" src_dir "${base}")
    string(REPLACE "." "/" build_dir "${name}")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${build_dir}")
    add_test(NAME "cmake_${name}"
        COMMAND "${CMAKE_COMMAND}" "-G${CMAKE_GENERATOR}"
            "-DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}"
            ${${name}_EXTRA_OPTIONS}
            "${CMAKE_CURRENT_SOURCE_DIR}/${src_dir}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${build_dir}")
endmacro()

macro(add_cmake_test_generate name)
    add_cmake_test_generate_variant("${name}" "${name}")
endmacro()

add_cmake_test_generate(features)
add_cmake_test_generate(qt_make_output_file)

=== examples/network/CMakeLists.txt ===
if(NOT TARGET Qt::Network)
    return()
endif()
qt_internal_add_example(download)
qt_internal_add_example(downloadmanager)
if(NOT INTEGRITY)
    qt_internal_add_example(dnslookup)
endif()
if(TARGET Qt::Widgets)
    qt_internal_add_example(blockingfortuneclient)
    qt_internal_add_example(broadcastreceiver)
    qt_internal_add_example(broadcastsender)
    qt_internal_add_example(http)
    qt_internal_add_example(loopback)
    qt_internal_add_example(threadedfortuneserver)
    qt_internal_add_example(googlesuggest)
    qt_internal_add_example(torrent)
    qt_internal_add_example(multicastreceiver)
    qt_internal_add_example(multicastsender)
    qt_internal_add_example(fortuneclient)
    qt_internal_add_example(fortuneserver)
endif()
if(QT_FEATURE_processenvironment AND TARGET Qt::Widgets)
    qt_internal_add_example(network-chat)
endif()
if(QT_FEATURE_ssl AND TARGET Qt::Widgets)
    qt_internal_add_example(securesocketclient)
endif()
if(QT_FEATURE_dtls AND TARGET Qt::Widgets)
    qt_internal_add_example(secureudpserver)
    qt_internal_add_example(secureudpclient)
endif()
if(QT_FEATURE_sctp AND TARGET Qt::Widgets)
    qt_internal_add_example(multistreamserver)
    qt_internal_add_example(multistreamclient)
endif()

=== examples/opengl/CMakeLists.txt ===
qt_internal_add_example(hellowindow)
qt_internal_add_example(paintedwindow)
qt_internal_add_example(openglwindow)
qt_internal_add_example(qopenglwindow)
if(TARGET Qt::Widgets)
    qt_internal_add_example(contextinfo)
    qt_internal_add_example(threadedqopenglwidget)
    qt_internal_add_example(2dpainting)
    qt_internal_add_example(hellogl2)
    qt_internal_add_example(qopenglwidget)
    qt_internal_add_example(cube)
    qt_internal_add_example(textures)
    qt_internal_add_example(hellogles3)
    qt_internal_add_example(computegles31)
endif()

=== examples/qpa/CMakeLists.txt ===
if(NOT TARGET Qt::Gui)
    return()
endif()
qt_internal_add_example(windows)
qt_internal_add_example(qrasterwindow)

=== src/3rdparty/CMakeLists.txt ===
# special case skip regeneration
# The file is maintained manually

if(QT_FEATURE_gui AND QT_FEATURE_png AND NOT QT_FEATURE_system_png)
    add_subdirectory(libpng)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledLibpng)

if(QT_FEATURE_gui AND QT_FEATURE_jpeg AND NOT QT_FEATURE_system_jpeg)
    add_subdirectory(libjpeg)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledLibjpeg)

if(QT_FEATURE_gui AND QT_FEATURE_freetype AND NOT QT_FEATURE_system_freetype)
    add_subdirectory(freetype)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledFreetype)

if(QT_FEATURE_gui AND QT_FEATURE_harfbuzz AND NOT QT_FEATURE_system_harfbuzz)
    add_subdirectory(harfbuzz-ng)
endif()
qt_install_3rdparty_library_wrap_config_extra_file(BundledHarfbuzz)

if (ANDROID)
    add_subdirectory(gradle)
endif()

=== src/printsupport/CMakeLists.txt ===
# Generated from printsupport.pro.

#####################################################################
## PrintSupport Module:
#####################################################################

qt_internal_add_module(PrintSupport
    PLUGIN_TYPES printsupport
    SOURCES
        kernel/qpaintengine_alpha.cpp kernel/qpaintengine_alpha_p.h
        kernel/qplatformprintdevice.cpp kernel/qplatformprintdevice.h
        kernel/qplatformprintersupport.cpp kernel/qplatformprintersupport.h
        kernel/qplatformprintplugin.cpp kernel/qplatformprintplugin.h
        kernel/qprint.cpp kernel/qprint_p.h
        kernel/qprintdevice.cpp kernel/qprintdevice_p.h
        kernel/qprintengine.h
        kernel/qprintengine_pdf.cpp kernel/qprintengine_pdf_p.h
        kernel/qprinter.cpp kernel/qprinter.h kernel/qprinter_p.h
        kernel/qprinterinfo.cpp kernel/qprinterinfo.h kernel/qprinterinfo_p.h
        kernel/qtprintsupportglobal.h kernel/qtprintsupportglobal_p.h
    DEFINES
        QT_NO_FOREACH
        QT_NO_USING_NAMESPACE
    INCLUDE_DIRECTORIES
        dialogs
        widgets
    LIBRARIES
        Qt::CorePrivate
        Qt::GuiPrivate
        Qt::WidgetsPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
        Qt::Widgets
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
        Qt::GuiPrivate
        Qt::WidgetsPrivate
    GENERATE_CPP_EXPORTS
)

#### Keys ignored in scope 1:.:.:printsupport.pro:<TRUE>:
# QMAKE_LIBS = "$$QMAKE_LIBS_PRINTSUPPORT"

## Scopes:
#####################################################################

qt_internal_extend_target(PrintSupport CONDITION MACOS
    SOURCES
        platform/macos/qcocoaprintdevice.mm platform/macos/qcocoaprintdevice_p.h
        platform/macos/qcocoaprintersupport.mm platform/macos/qcocoaprintersupport_p.h
        platform/macos/qpaintengine_mac.mm platform/macos/qpaintengine_mac_p.h
        platform/macos/qprintengine_mac.mm platform/macos/qprintengine_mac_p.h
    PUBLIC_LIBRARIES
        ${FWApplicationServices}
        Cups::Cups
    NO_PCH_SOURCES
        "platform/macos/qcocoaprintersupport.mm"
)

qt_internal_extend_target(PrintSupport CONDITION WIN32
    SOURCES
        platform/windows/qprintengine_win.cpp platform/windows/qprintengine_win_p.h
        platform/windows/qwindowsprintdevice.cpp platform/windows/qwindowsprintdevice_p.h
        platform/windows/qwindowsprintersupport.cpp platform/windows/qwindowsprintersupport_p.h
    LIBRARIES
        gdi32
        user32
    PUBLIC_LIBRARIES
        comdlg32
        winspool
    NO_PCH_SOURCES
        "platform/windows/qwindowsprintersupport.cpp"
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_printpreviewwidget
    SOURCES
        kernel/qpaintengine_preview.cpp kernel/qpaintengine_preview_p.h
        widgets/qprintpreviewwidget.cpp widgets/qprintpreviewwidget.h
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_cups AND UNIX AND NOT APPLE
    SOURCES
        kernel/qcups.cpp kernel/qcups_p.h
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_cupsjobwidget AND UNIX AND NOT APPLE
    SOURCES
        widgets/qcupsjobwidget.cpp widgets/qcupsjobwidget.ui widgets/qcupsjobwidget_p.h
    ENABLE_AUTOGEN_TOOLS
        uic
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_printdialog
    SOURCES
        dialogs/qabstractprintdialog.cpp dialogs/qabstractprintdialog.h dialogs/qabstractprintdialog_p.h
        dialogs/qpagesetupdialog.cpp dialogs/qpagesetupdialog.h dialogs/qpagesetupdialog_p.h
        dialogs/qpagesetupwidget.ui
        dialogs/qprintdialog.h
    ENABLE_AUTOGEN_TOOLS
        uic
)

if(QT_FEATURE_printdialog)
    # Resources:
    set(qprintdialog_resource_files
        "dialogs/images/zoom-fit-page-24.png"
        "dialogs/images/zoom-fit-page-32.png"
        "dialogs/images/zoom-fit-width-24.png"
        "dialogs/images/zoom-fit-width-32.png"
        "dialogs/images/go-first-24.png"
        "dialogs/images/go-first-32.png"
        "dialogs/images/go-last-24.png"
        "dialogs/images/go-last-32.png"
        "dialogs/images/go-next-24.png"
        "dialogs/images/go-next-32.png"
        "dialogs/images/go-previous-24.png"
        "dialogs/images/go-previous-32.png"
        "dialogs/images/layout-landscape-24.png"
        "dialogs/images/layout-landscape-32.png"
        "dialogs/images/layout-portrait-24.png"
        "dialogs/images/layout-portrait-32.png"
        "dialogs/images/page-setup-24.png"
        "dialogs/images/page-setup-32.png"
        "dialogs/images/printer-24.png"
        "dialogs/images/printer-32.png"
        "dialogs/images/view-pages-overview-24.png"
        "dialogs/images/view-pages-overview-32.png"
        "dialogs/images/view-pages-single-24.png"
        "dialogs/images/view-pages-single-32.png"
        "dialogs/images/view-pages-facing-24.png"
        "dialogs/images/view-pages-facing-32.png"
        "dialogs/images/zoom-in-24.png"
        "dialogs/images/zoom-in-32.png"
        "dialogs/images/zoom-out-24.png"
        "dialogs/images/zoom-out-32.png"
    )

    qt_internal_add_resource(PrintSupport "qprintdialog"
        PREFIX
            "/qt-project.org/dialogs/qprintpreviewdialog"
        BASE
            "dialogs"
        FILES
            ${qprintdialog_resource_files}
    )
    set(qprintdialog1_resource_files
        "dialogs/images/status-color.png"
        "dialogs/images/status-gray-scale.png"
    )

    qt_internal_add_resource(PrintSupport "qprintdialog1"
        PREFIX
            "/qt-project.org/dialogs/qprintdialog"
        BASE
            "dialogs"
        FILES
            ${qprintdialog1_resource_files}
    )
endif()

qt_internal_extend_target(PrintSupport CONDITION MACOS AND QT_FEATURE_printdialog
    SOURCES
        dialogs/qpagesetupdialog_mac.mm
        dialogs/qprintdialog_mac.mm
    LIBRARIES
        ${FWAppKit}
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_printdialog AND WIN32
    SOURCES
        dialogs/qpagesetupdialog_win.cpp
        dialogs/qprintdialog_win.cpp
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_printdialog AND UNIX AND NOT APPLE
    SOURCES
        dialogs/qpagesetupdialog_unix.cpp dialogs/qpagesetupdialog_unix_p.h
        dialogs/qprintdialog_unix.cpp
        dialogs/qprintpropertieswidget.ui
        dialogs/qprintsettingsoutput.ui
        dialogs/qprintwidget.ui
    INCLUDE_DIRECTORIES
        ${QtBase_SOURCE_DIR}/src/plugins/printsupport/cups
    ENABLE_AUTOGEN_TOOLS
        uic
)

qt_internal_extend_target(PrintSupport CONDITION QT_FEATURE_printpreviewdialog
    SOURCES
        dialogs/qprintpreviewdialog.cpp dialogs/qprintpreviewdialog.h
)
qt_internal_add_docs(PrintSupport
    doc/qtprintsupport.qdocconf
)

=== src/sql/CMakeLists.txt ===
# Generated from sql.pro.

#####################################################################
## Sql Module:
#####################################################################

qt_internal_add_module(Sql
    PLUGIN_TYPES sqldrivers
    SOURCES
        compat/removed_api.cpp
        kernel/qsqlcachedresult.cpp kernel/qsqlcachedresult_p.h
        kernel/qsqldatabase.cpp kernel/qsqldatabase.h
        kernel/qsqldriver.cpp kernel/qsqldriver.h kernel/qsqldriver_p.h
        kernel/qsqldriverplugin.cpp kernel/qsqldriverplugin.h
        kernel/qsqlerror.cpp kernel/qsqlerror.h
        kernel/qsqlfield.cpp kernel/qsqlfield.h
        kernel/qsqlindex.cpp kernel/qsqlindex.h
        kernel/qsqlnulldriver_p.h
        kernel/qsqlquery.cpp kernel/qsqlquery.h
        kernel/qsqlrecord.cpp kernel/qsqlrecord.h
        kernel/qsqlresult.cpp kernel/qsqlresult.h kernel/qsqlresult_p.h
        kernel/qtsqlglobal.h kernel/qtsqlglobal_p.h
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_FOREACH
        QT_NO_USING_NAMESPACE
    LIBRARIES
        Qt::CorePrivate
    PUBLIC_LIBRARIES
        Qt::Core
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
    NO_PCH_SOURCES
        "compat/removed_api.cpp"
    PRECOMPILED_HEADER
        "../corelib/global/qt_pch.h"
    GENERATE_CPP_EXPORTS
)

#### Keys ignored in scope 1:.:.:sql.pro:<TRUE>:
# SQL_P = "sql"

## Scopes:
#####################################################################

qt_internal_extend_target(Sql CONDITION MSVC AND (TEST_architecture_arch STREQUAL "i386")
    LINK_OPTIONS
        "/BASE:0x62000000"
)

qt_internal_extend_target(Sql CONDITION QT_FEATURE_sqlmodel
    SOURCES
        models/qsqlquerymodel.cpp models/qsqlquerymodel.h models/qsqlquerymodel_p.h
        models/qsqlrelationaldelegate.cpp models/qsqlrelationaldelegate.h
        models/qsqlrelationaltablemodel.cpp models/qsqlrelationaltablemodel.h
        models/qsqltablemodel.cpp models/qsqltablemodel.h models/qsqltablemodel_p.h
)
qt_internal_add_docs(Sql
    doc/qtsql.qdocconf
)

# include the snippet projects for developer-builds
if(QT_FEATURE_private_tests)
    add_subdirectory(doc/snippets/code)
    add_subdirectory(doc/snippets/sqldatabase)
endif()

=== tests/benchmarks/CMakeLists.txt ===
# Generated from benchmarks.pro.

add_subdirectory(corelib)
if(TARGET Qt::DBus)
    add_subdirectory(dbus)
endif()
if(TARGET Qt::Gui)
    add_subdirectory(gui)
endif()
if(TARGET Qt::Network)
    add_subdirectory(network)
endif()
if(TARGET Qt::Sql)
    add_subdirectory(sql)
endif()
if(TARGET Qt::Test)
    add_subdirectory(testlib)
endif()
if(TARGET Qt::Widgets)
    add_subdirectory(widgets)
endif()

=== examples/corelib/serialization/CMakeLists.txt ===
qt_internal_add_example(cbordump)
qt_internal_add_example(convert)
qt_internal_add_example(savegame)

=== examples/dbus/complexpingpong/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(complexpingpong LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/dbus/complexpingpong")

find_package(Qt6 REQUIRED COMPONENTS Core DBus)

qt_add_executable(complexping
    complexping.cpp complexping.h
    ping-common.h
)

target_link_libraries(complexping PRIVATE
    Qt6::Core
    Qt6::DBus
)

qt_add_executable(complexpong
    complexpong.cpp complexpong.h
)

target_link_libraries(complexpong PRIVATE
    Qt6::Core
    Qt6::DBus
)

install(TARGETS complexping complexpong
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== debian/control ===
Source: qt6-base
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Patrick Franz <deltaone@debian.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>
Build-Depends: cmake (>= 3.24~),
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               dh-exec,
               firebird-dev [kfreebsd-any linux-any],
               libatspi2.0-dev,
               libb2-dev,
               libcups2-dev,
               libdbus-1-dev,
               libdouble-conversion-dev,
               libdrm-dev [linux-any],
               libfontconfig-dev,
               libfreetype-dev,
               libgbm-dev [linux-any],
               libgl-dev,
               libgl1-mesa-dev,
               libgles-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libharfbuzz-dev,
               libicu-dev,
               libinput-dev [linux-any],
               libjpeg-dev,
               libkrb5-dev,
               liblttng-ust-dev [linux-any],
               libmd4c-dev,
               libmd4c-html0-dev,
               libmtdev-dev [linux-any],
               libpcre2-dev,
               libpng-dev,
               libpq-dev,
               libproxy-dev,
               libsctp-dev [linux-any],
               libsqlite3-dev,
               libssl-dev,
               libsystemd-dev [linux-any],
               libts-dev,
               libudev-dev [linux-any],
               libvulkan-dev [linux-any],
               libwayland-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-glx0-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-util-dev,
               libxcb-xfixes0-dev,
               libxcb-xinerama0-dev,
               libxcb-xinput-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               libzstd-dev,
               ninja-build,
               pkg-config,
               pkg-kde-tools (>= 0.15.17~),
               qt6-base-dev:native <cross>,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Section: libs
Homepage: https://www.qt.io/developers/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt6/qt6-base.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt6/qt6-base

Package: libqt6core6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Provides: qt6-base-abi (= 6.4.2)
Depends: shared-mime-info, ${misc:Depends}, ${shlibs:Depends}
Recommends: qt6-translations-l10n
Description: Qt 6 core module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtCore module contains core non-GUI functionality.

Package: libqt6concurrent6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 concurrent module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtConcurrent module contains functionality to support concurrent execution
 of program code.

Package: libqt6dbus6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 D-Bus module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtDBus module is a Unix-only library that you can use to make Inter-Process
 Communication using the D-Bus protocol.
 .
 Applications using the QtDBus module can provide services to other, remote
 applications by exporting objects, as well as use services exported by those
 applications by placing calls and accessing properties.

Package: libqt6gui6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Breaks: qt6-qpa-plugins (<< 6.3.1+dfsg-6~)
Replaces: qt6-qpa-plugins (<< 6.3.1+dfsg-6~)
Recommends: qt6-gtk-platformtheme, qt6-qpa-plugins
Description: Qt 6 GUI module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtGui module extends QtCore with GUI functionality.

Package: qt6-qpa-plugins
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Breaks: libqt6gui6 (<< 6.3.1+dfsg-6~),
        libqt6network6 (<< 6.2.4+dfsg-5~),
        libqt6opengl6 (<< 6.3.1+dfsg-6~)
Description: Qt 6 QPA plugins
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the following plugins:
   * uioTouch Plugin
   * VNC Plugin

Package: qt6-gtk-platformtheme
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 GTK+ 3 platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package provides the GTK+ 3 platform theme, which makes Qt use
 native icon themes, fonts, and dialogs on GTK-based environments.

Package: qt6-xdgdesktopportal-platformtheme
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 XDG Desktop Portal platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package provides the XDG Desktop portal platform theme, which makes
 Qt use native file dialogs on Flatpak/Snap based environments.

Package: libqt6opengl6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: qt6-qpa-plugins (<< 6.3.1+dfsg-6~)
Replaces: qt6-qpa-plugins (<< 6.3.1+dfsg-6~)
Description: Qt 6 OpenGL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.

Package: libqt6openglwidgets6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 OpenGL widgets module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.
 .
 The OpenGL widgets module provides the widget for rendering OpenGL graphics.

Package: libqt6network6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${libssl:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: qt6-qpa-plugins (<< 6.2.4+dfsg-5~)
Replaces: qt6-qpa-plugins (<< 6.2.4+dfsg-5~)
Description: Qt 6 network module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtNetwork module offers classes that allow you to write TCP/IP clients and
 servers. It provides classes to make network programming easier and portable.

Package: libqt6sql6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libqt6sql6-sqlite | libqt6sql6-mysql | libqt6sql6-odbc | libqt6sql6-psql | libqt6sql6-ibase
Description: Qt 6 SQL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSql module helps you provide seamless database integration to your Qt
 applications.

Package: libqt6sql6-mysql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 MySQL database driver
 This package contains the MySQL plugin for Qt 6.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MySQL DB.

Package: libqt6sql6-odbc
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 ODBC database driver
 This package contains the ODBC plugin for Qt 6.
 .
 Install it if you intend to use or write Qt programs that are to access an
 ODBC DB.

Package: libqt6sql6-psql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 PostgreSQL database driver
 This package contains the PostgreSQL plugin for Qt 6.
 .
 Install it if you intend to use or write Qt programs that are to access a
 PostgreSQL DB.

Package: libqt6sql6-sqlite
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 SQLite 3 database driver
 This package contains the SQLite 3 plugin for Qt 6.
 .
 Install it if you intend to use or write Qt programs that are to access an
 SQLite 3 DB.

Package: libqt6sql6-ibase
Architecture: kfreebsd-any linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 Firebird database driver
 This package contains the Firebird plugin for Qt 6.
 .
 Install it if you intend to use or write Qt programs that are to access a
 Firebird/InterBase DB.

Package: libqt6test6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 test module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtTest module provides classes for unit testing Qt applications and
 libraries.

Package: libqt6widgets6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 widgets module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtWidgets module extends QtGui with C++ widget functionality.

Package: libqt6xml6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 XML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtXml module provides a stream reader and writer for XML documents,
 and C++ implementations of SAX and DOM.

Package: libqt6printsupport6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcups2
Description: Qt 6 print support module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Use already defined DEB_HOST_* variables.
include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
sslpkgname := $(shell dpkg-query --show '--showformat=$${Depends}' libssl-dev | cut -d ' ' -f1)

ifneq (,$(filter libqt6sql6-ibase,$(shell dh_listpackages)))
        extra_cmake_args += -DFEATURE_sql_ibase=ON
else
        extra_cmake_args += -DFEATURE_sql_ibase=OFF
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
        extra_cmake_args += -DFEATURE_sctp=ON
else
        extra_cmake_args += -DFEATURE_sctp=OFF
endif

# cross-builds
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	extra_cmake_args += \
		-DQT_HOST_PATH=/usr \
		-DQT_HOST_PATH_CMAKE_DIR=/usr/lib/${DEB_BUILD_MULTIARCH}/cmake \
		-DQT_BUILD_TOOLS_WHEN_CROSSCOMPILING=ON
endif

%:
	dh $@ --with pkgkde_symbolshelper --buildsystem=cmake+ninja


override_dh_auto_configure:
	dh_auto_configure -- \
		--log-level=STATUS \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DINSTALL_BINDIR=lib/qt6/bin \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_LIBEXECDIR=lib/qt6/libexec \
		-DINSTALL_ARCHDATADIR=lib/$(DEB_HOST_MULTIARCH)/qt6 \
		-DINSTALL_EXAMPLESDIR=lib/$(DEB_HOST_MULTIARCH)/qt6/examples \
		-DINSTALL_DATADIR=share/qt6 \
		-DINSTALL_HOSTDATADIR=lib/$(DEB_HOST_MULTIARCH)/qt6 \
		-DINSTALL_DOCDIR=share/qt6/doc \
		-DINSTALL_SYSCONFDIR=/etc/xdg \
		-DINSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH)/qt6 \
		-DINSTALL_PLUGINDIR=lib/$(DEB_HOST_MULTIARCH)/qt6/plugins \
		-DINSTALL_TRANSLATIONDIR=share/qt6/translations \
		-DINSTALL_MKSPECSDIR=lib/$(DEB_HOST_MULTIARCH)/qt6/mkspecs \
		-DINSTALL_PUBLICBINDIR=bin \
		-DBUILD_EXAMPLES=ON \
		-DFEATURE_mimetype_database=OFF \
		-DFEATURE_dbus_linked=ON \
		-DFEATURE_accessibility=ON \
		-DFEATURE_doubleconversion=ON \
		-DFEATURE_glib=ON \
		-DFEATURE_icu=ON \
		-DFEATURE_pcre2=ON \
		-DFEATURE_system_pcre2=ON \
		-DFEATURE_zlib=ON \
		-DFEATURE_ssl=ON \
		-DFEATURE_libproxy=ON \
		-DFEATURE_system_proxies=ON \
		-DFEATURE_cups=ON \
		-DFEATURE_fontconfig=ON \
		-DFEATURE_freetype=ON \
		-DFEATURE_harfbuzz=ON \
		-DFEATURE_gtk=ON \
		-DFEATURE_directfb=OFF \
		-DFEATURE_sql_odbc=ON \
		-DFEATURE_sql_mysql=ON \
		-DFEATURE_sql_psql=ON \
		-DFEATURE_sql_sqlite=ON \
		-DFEATURE_system_sqlite=ON \
		-DFEATURE_jpeg=ON \
		-DFEATURE_system_jpeg=ON \
		-DFEATURE_png=ON \
		-DFEATURE_system_png=ON \
		-DFEATURE_system_libb2=ON \
		-DFEATURE_rpath=OFF \
		-DFEATURE_relocatable=OFF \
		$(extra_cmake_args)


execute_after_dh_auto_install:
	# Policy § 10.4. Remove this if https://bugs.debian.org/904409 gets fixed.
	sed -i 's,bin/env perl,bin/perl,' debian/tmp/usr/lib/qt6/libexec/*.pl \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/qt6/mkspecs/features/data/unix/findclasslist.pl

	# Reproducible builds: remove build paths from .prl files
	sed -i -e '/^QMAKE_PRL_BUILD_DIR/d' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6*.prl

	# Specifies parameters to pass to the platform plugin.
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/qt6
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/' debian/qt.conf.in \
		> debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/qt6/qt6.conf

	# Inject cross-wrapper for qmake6
	mkdir -p debian/tmp/usr/bin
	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		-e 's/@DEB_HOST_GNU_TYPE@/$(DEB_HOST_GNU_TYPE)/g' \
		< debian/qmake-cross-wrapper.in > debian/tmp/usr/bin/$(DEB_HOST_GNU_TYPE)-qmake6
	chmod +x debian/tmp/usr/bin/$(DEB_HOST_GNU_TYPE)-qmake6

	# Fix Qt6::qmake IMPORTED_LOCATION, see https://bugs.debian.org/1030980
	sed -i 's,lib/qt6/bin/qmake,bin/$(DEB_HOST_GNU_TYPE)-qmake6,' \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6CoreTools/Qt6CoreToolsTargets-none.cmake

override_dh_makeshlibs:
	dh_makeshlibs -XlibQt6EglFSDeviceIntegration -XlibQt6EglFsKmsGbmSupport -XlibQt6EglFsKmsSupport -XlibQt6XcbQpa

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

execute_after_dh_shlibdeps-arch:
	echo libssl:Depends=$(sslpkgname) >> debian/libqt6network6.substvars

ifeq ($(DEB_HOST_ARCH_CPU),arm64)
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=968670
override_dh_dwz:
endif
